%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 2;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}

%bcond_with check
%global debug_package %{nil}

%global crate tower

Name:           rust-tower
Version:        0.4.13
Release:    1%{?dist}
Summary:        Modular and reusable components for building robust clients and servers

License:        MIT
URL:            https://crates.io/crates/tower
Source0:         %{crates_source}

BuildRequires:  rust-packaging >= 21

%global _description %{expand:
Tower is a library of modular and reusable components for building
robust clients and servers.}

%description %{_description}

%package        devel
Summary:        %{summary}
BuildArch:      noarch

%description    devel %{_description}

This package contains library source intended for building other packages which
use the "%{crate}" crate.

%files          devel
%license %{crate_instdir}/LICENSE
%doc %{crate_instdir}/CHANGELOG.md
%doc %{crate_instdir}/README.md
%{crate_instdir}/

%package     -n %{name}+default-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+default-devel %{_description}

This package contains library source intended for building other packages which
use the "default" feature of the "%{crate}" crate.

%files       -n %{name}+default-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+__common-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+__common-devel %{_description}

This package contains library source intended for building other packages which
use the "__common" feature of the "%{crate}" crate.

%files       -n %{name}+__common-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+balance-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+balance-devel %{_description}

This package contains library source intended for building other packages which
use the "balance" feature of the "%{crate}" crate.

%files       -n %{name}+balance-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+buffer-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+buffer-devel %{_description}

This package contains library source intended for building other packages which
use the "buffer" feature of the "%{crate}" crate.

%files       -n %{name}+buffer-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+discover-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+discover-devel %{_description}

This package contains library source intended for building other packages which
use the "discover" feature of the "%{crate}" crate.

%files       -n %{name}+discover-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+filter-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+filter-devel %{_description}

This package contains library source intended for building other packages which
use the "filter" feature of the "%{crate}" crate.

%files       -n %{name}+filter-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+full-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+full-devel %{_description}

This package contains library source intended for building other packages which
use the "full" feature of the "%{crate}" crate.

%files       -n %{name}+full-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+futures-core-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+futures-core-devel %{_description}

This package contains library source intended for building other packages which
use the "futures-core" feature of the "%{crate}" crate.

%files       -n %{name}+futures-core-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+futures-util-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+futures-util-devel %{_description}

This package contains library source intended for building other packages which
use the "futures-util" feature of the "%{crate}" crate.

%files       -n %{name}+futures-util-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+hdrhistogram-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+hdrhistogram-devel %{_description}

This package contains library source intended for building other packages which
use the "hdrhistogram" feature of the "%{crate}" crate.

%files       -n %{name}+hdrhistogram-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+hedge-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+hedge-devel %{_description}

This package contains library source intended for building other packages which
use the "hedge" feature of the "%{crate}" crate.

%files       -n %{name}+hedge-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+indexmap-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+indexmap-devel %{_description}

This package contains library source intended for building other packages which
use the "indexmap" feature of the "%{crate}" crate.

%files       -n %{name}+indexmap-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+limit-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+limit-devel %{_description}

This package contains library source intended for building other packages which
use the "limit" feature of the "%{crate}" crate.

%files       -n %{name}+limit-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+load-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+load-devel %{_description}

This package contains library source intended for building other packages which
use the "load" feature of the "%{crate}" crate.

%files       -n %{name}+load-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+load-shed-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+load-shed-devel %{_description}

This package contains library source intended for building other packages which
use the "load-shed" feature of the "%{crate}" crate.

%files       -n %{name}+load-shed-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+log-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+log-devel %{_description}

This package contains library source intended for building other packages which
use the "log" feature of the "%{crate}" crate.

%files       -n %{name}+log-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+make-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+make-devel %{_description}

This package contains library source intended for building other packages which
use the "make" feature of the "%{crate}" crate.

%files       -n %{name}+make-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+pin-project-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+pin-project-devel %{_description}

This package contains library source intended for building other packages which
use the "pin-project" feature of the "%{crate}" crate.

%files       -n %{name}+pin-project-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+pin-project-lite-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+pin-project-lite-devel %{_description}

This package contains library source intended for building other packages which
use the "pin-project-lite" feature of the "%{crate}" crate.

%files       -n %{name}+pin-project-lite-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+rand-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+rand-devel %{_description}

This package contains library source intended for building other packages which
use the "rand" feature of the "%{crate}" crate.

%files       -n %{name}+rand-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+ready-cache-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+ready-cache-devel %{_description}

This package contains library source intended for building other packages which
use the "ready-cache" feature of the "%{crate}" crate.

%files       -n %{name}+ready-cache-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+reconnect-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+reconnect-devel %{_description}

This package contains library source intended for building other packages which
use the "reconnect" feature of the "%{crate}" crate.

%files       -n %{name}+reconnect-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+retry-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+retry-devel %{_description}

This package contains library source intended for building other packages which
use the "retry" feature of the "%{crate}" crate.

%files       -n %{name}+retry-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+slab-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+slab-devel %{_description}

This package contains library source intended for building other packages which
use the "slab" feature of the "%{crate}" crate.

%files       -n %{name}+slab-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+spawn-ready-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+spawn-ready-devel %{_description}

This package contains library source intended for building other packages which
use the "spawn-ready" feature of the "%{crate}" crate.

%files       -n %{name}+spawn-ready-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+steer-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+steer-devel %{_description}

This package contains library source intended for building other packages which
use the "steer" feature of the "%{crate}" crate.

%files       -n %{name}+steer-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+timeout-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+timeout-devel %{_description}

This package contains library source intended for building other packages which
use the "timeout" feature of the "%{crate}" crate.

%files       -n %{name}+timeout-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+tokio-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+tokio-devel %{_description}

This package contains library source intended for building other packages which
use the "tokio" feature of the "%{crate}" crate.

%files       -n %{name}+tokio-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+tokio-stream-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+tokio-stream-devel %{_description}

This package contains library source intended for building other packages which
use the "tokio-stream" feature of the "%{crate}" crate.

%files       -n %{name}+tokio-stream-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+tokio-util-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+tokio-util-devel %{_description}

This package contains library source intended for building other packages which
use the "tokio-util" feature of the "%{crate}" crate.

%files       -n %{name}+tokio-util-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+tracing-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+tracing-devel %{_description}

This package contains library source intended for building other packages which
use the "tracing" feature of the "%{crate}" crate.

%files       -n %{name}+tracing-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+util-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+util-devel %{_description}

This package contains library source intended for building other packages which
use the "util" feature of the "%{crate}" crate.

%files       -n %{name}+util-devel
%ghost %{crate_instdir}/Cargo.toml

%prep
%autosetup -n %{crate}-%{version_no_tilde} -p1
%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires

%build
%cargo_build

%install
%cargo_install

%if %{with check}
%check
%cargo_test
%endif

%changelog
* Tue Jul 23 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.4.13-1
- initial build
